version: '3.7'
services:
  db:
  	environment:
    	MYSQL_ROOT_PASSWORD:
        MYSQL_PASSWORD:

  db_backup:
    environment:
      DB_USER:
      DB_PASS:

  #Freeradius server
  freeradius:
    image: "freeradius/freeradius-server:latest-alpine"
    container_name: igroove_freeradius
    restart: unless-stopped
    #command: "-X"
    build:
      context: ./provision/docker/freeradius
    ports:
      - "1812:1812/udp"
      - "1813:1813/udp"
    volumes:
      - "./provision/docker/freeradius/dictionary:/etc/raddb/dictionary"
      - "./provision/docker/freeradius/clients.conf:/etc/raddb/clients.conf"
      - "./provision/docker/freeradius/sql:/etc/raddb/mods-enabled/sql"
      - "./provision/docker/freeradius/ldap_AD:/etc/raddb/mods-enabled/ldap"
      - "./provision/docker/freeradius/proxy.conf:/etc/raddb/proxy.conf"
      - "./provision/docker/freeradius/realm.conf:/etc/raddb/realm.conf"
      - "./provision/docker/freeradius/default_site:/etc/raddb/sites-enabled/default"
    environment:
      - DB_NAME=igroove
      - DB_HOST=db
      - DB_USER=igroove
      - DB_PASS=igroove
      - DB_PORT=3306
      - AD_HOST=ldaps://dc
      - AD_BASE_DN=dc=igroove,dc=local
      - AD_BIND_USER=cn=Administrator,cn=Users,dc=igroove,dc=local
      - AD_BIND_PASS=Az-12345
      - RADIUS_KEY=apauth
      - RAD_CLIENTS=10.0.0.0/24
    depends_on:
      - db

  #ActiveDirectory simulation
  dc:
    image: nowsci/samba-domain
    container_name: igroove_dc
    restart: unless-stopped
    privileged: true
    #user: "1000:50"
    environment:
      DOMAIN: igroove.local
      DOMAINPASS: Az-12345
      DNSFORWARDER: 8.8.8.8
      INSECURELDAP: "true"
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - /var/lib/samba
      - /etc/samba/external
      #- ./provision/docker/data/samba/:/var/lib/samba:cached
      #- ./provision/docker/samba/etc:/etc/samba/external:cached
      - ./provision/docker/logs/samba:/var/log/supervisor:cached
    hostname: dc
    extra_hosts:
      - dc.igroove.local:127.0.0.1
    ports:
      - 53:53
      - 53:53/udp
      - 88:88
      - 88:88/udp
      - 135:135
      - 137-138:137-138/udp
      - 139:139
      - 389:389
      - 389:389/udp
      - 445:445
      - 464:464
      - 464:464/udp
      - 636:636
      - 1024-1044:1024-1044
      - 3268-3269:3268-3269
    dns_search:
      - igroove.local
    #dns:
    #- 8.8.4.4
    #- 8.8.8.8

  #Macos permission fix
  #db:
  #  user: "1000:50"
  #  command: [ "--default-authentication-plugin=mysql_native_password","--innodb_use_native_aio=0" ]
  #
  #php:
  #  build:
  #    args:
  #      UID: 1000
  #      GID: 50
  #
  #rabbitmq:
  #  user: "1000:50"